package com.example.floradex20

//import com.example.floradex20.R
//import com.example.floradex20.Plant
//import com.squareup.picasso.Picasso
//import android.support.v4.app.FragmentActivity
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import okhttp3.OkHttpClient
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import androidx.constraintlayout.widget.ConstraintLayout


//Cosas para que lleguen las flores
//private const val TOKEN: String = "cMyugCJvk-U_xoi31FVBgoEqZiuRnDYpP8fv8Vfiejg"
private const val  BASE_URL = "https://trefle.io/"
//var slug: String = "prunella-vulgaris"

//Creo que mas cosas para que lleguen las flores
object ServiceBuilder {

    val client = OkHttpClient.Builder().build()

    var retrofit: Retrofit = Retrofit.Builder()
        .baseUrl(BASE_URL)
        .addConverterFactory(GsonConverterFactory.create())
        .client(client)
        .build()

    fun <T> buildService(service: Class<T>): T {
        return retrofit.create(service)
    }
}


//Main Activity
class MainActivity : AppCompatActivity(), FlowerAdapter.OnItemClickListener {
    private lateinit var recyclerView: RecyclerView
    private lateinit var plants: List<Data>

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val request = ServiceBuilder.buildService(TrefleService::class.java)
        val call : Call<PlantListss> = request.getPlants(getString(R.string.TOKEN))


        //Esta parte hay que loop it para que haga mas de 1 request al API
        call.enqueue(object : Callback<PlantListss> {
            override fun onResponse(call: Call<PlantListss>, response: Response<PlantListss>) {

                if (response.isSuccessful) {

                    recyclerView = findViewById<RecyclerView>(R.id.recyclerView)

                    recyclerView.apply {

                        setHasFixedSize(true)
                        plants = response.body()!!.data
                        adapter = FlowerAdapter(plants, this@MainActivity)
                        layoutManager = LinearLayoutManager(this@MainActivity)

                        //Aqui hay que chequiar si el API response llega bien
                        recyclerView.setAdapter(adapter)
                        recyclerView.setLayoutManager(layoutManager)
                    }
//
                }
            }

            override fun onFailure(call: Call<PlantListss>, t: Throwable) {
                Toast.makeText(this@MainActivity, "${t.message}", Toast.LENGTH_SHORT).show()
            }
        })
        }

    override fun onItemClick(position: Int){
        //Empezar el activity de Jose
        var plant_info = arrayOf<String>(plants[position].common_name.toString(), plants[position].scientific_name.toString()
        , plants[position].year.toString(), plants[position].author.toString(), plants[position].image_url.toString())
        val intent = Intent(this, ventana::class.java).apply {
            putExtra("plant_info", plant_info)
        }
        startActivity(intent)
        Log.i("Position", plant_info.get(0))
    }

}

